require('default')
require('stage')
require('player')
require('control')
require('utils')
require('score')
require('enemy')
require('collision')

function love.load()

	rect = { x = 100, y = 100, width = 100, height = 100, dragging = { active = false, diffX = 0, diffY = 0 } }
  poko = player


  world:setCallbacks(beginContact, endContact, preSolve, postSolve)
end

function love.update(dt)
	world:update(dt)
  goal:update()
  goal:updateMessage()

  if finger.dragging.active then
    finger:trajectory()
    player:trajectory()
    stage.color = { stage.color[1] - finger.dragging.distance, stage.color[2]- finger.dragging.distance, stage.color[3]- finger.dragging.distance }
  end

  if finger.dragging.released then    
    -- poko.body:setLinearVelocity(finger.dragging.diffX, finger.dragging.diffY)
    poko.body:setLinearVelocity(finger.dragging.diffX * 10,  finger.dragging.diffY * 10)
    poko.body:applyForce(finger.dragging.diffX, finger.dragging.diffY)
    poko.body:setLinearDamping( 1 )
    poko:resetTrajectory()
    print(poko.body:getLinearVelocity())
    finger.dragging.released = false
  end

  if rect.dragging.active then
    rect.x = love.mouse.getX() - rect.dragging.diffX
    rect.y = love.mouse.getY() - rect.dragging.diffY
  end
  
  if cond then
      --do
  end

  -- lily.body:setPosition(650/2, 650/2)
  -- lily.body:setLinearVelocity(10, 100)  

end

function love.draw()

  stage:draw()
  showStatus()
  showScore()

  poko:drawCharacter()
  poko:drawMessage()
  poko:drawTrajectory()

  enemy1:drawEnemy1()
  enemy2:drawEnemy2()

  love.graphics.setFont(default.font.body)
  -- love.graphics.rectangle("fill", rect.x, rect.y, rect.width, rect.height)
  love.graphics.setColor(250, 250, 250)

  finger:show()
  goal:draw()
  goal:drawMessage()
end

function love.mousepressed(x, y, button, istouch)

  finger.x = x
  finger.y = y

  if button == 1 then
    finger.dragging.active = true
  end

  if button == 1 and x > finger.x and x < finger.x and y > finger.y and y < finger.y then
    finger.dragging.active = true
    finger.dragging.diffX = x - finger.x
    finger.dragging.diffY = y - finger.y
  end

  if button == 1
  and x > rect.x and x < rect.x + rect.width
  and y > rect.y and y < rect.y + rect.height
  then
    rect.dragging.active = true
    rect.dragging.diffX = x - rect.x
    rect.dragging.diffY = y - rect.y
  end
end

function love.mousereleased(x, y, button, istouch)
  if button == 1 then rect.dragging.active = false end
  if button == 1 then 
    finger.dragging.active = false 
    finger.dragging.released = true
  end
  reset_finger()

end


function distance ( x1, y1, x2, y2 )
  local dx = x1 - x2
  local dy = y1 - y2
  return math.sqrt ( dx * dx + dy * dy )
end


function reset_finger()
  finger.x = 0
  finger.y = 0
  finger.angle = 0
  finger.dragging.fromX = 0
  finger.dragging.fromY = 0
  finger.dragging.toX = 0
  finger.dragging.toY = 0
  finger.dragging.distance = 0
  finger.dragging.active = false
  finger.dragging.angle = 0
  stage.color = default.stage.color
end