player = {}

player.image = love.graphics.newImage('assets/happymoon.png')
player.originx = function(self) return self.image:getWidth() / 2 end
player.originy = function(self) return self.image:getHeight() / 2 end
player.x = stage.width / 2
player.y = stage.height / 2
player.radius = 42
player.segments = 50
player.mass = 0.5
player.color = {190, 190, 190}
player.direction = {}

player.dragging = {}
player.dragging.fromX = 0
player.dragging.fromY = 0
player.dragging.toX = 0
player.dragging.toY = 0
player.dragging.active = false
player.dragging.diffX = 0
player.dragging.diffY = 0

player.body = love.physics.newBody(world, player.x, player.y, "dynamic")
player.body:setLinearDamping(2)
player.shape = love.physics.newCircleShape(player.radius)
player.fixture = love.physics.newFixture(player.body, player.shape, 0.2)
player.fixture:setRestitution(1)
player.fixture:setUserData("HappyMoonPoko")
player.message = 'Welcome, to moon wars'
player.drawCharacter = function (self)
	local img = self.image
	love.graphics.setColor(self.color)
	-- love.graphics.setLineWidth( 10 )
	-- love.graphics.circle( 'line', self.body:getX(), self.body:getY(), self.radius, self.segments )
	-- love.graphics.setColor(255,255,255)
	x = img:getWidth()
	y = img:getHeight()
	-- love.graphics.draw(img, self.body:getX(), self.body:getY(), ox = self.originx, oy = self.originy)
	love.graphics.draw(img, self.body:getX(), self.body:getY(), math.rad(0), 1, 1, x / 2, y / 2)
	player.body:setMass(self.mass)
end
player.trajectory = function(self)
	self.dragging.fromX = self.body:getX()
	self.dragging.fromY = self.body:getY()
	self.dragging.toX = finger.dragging.diffX + self.body:getX()
	self.dragging.toY = finger.dragging.diffY + self.body:getY()
end
player.drawTrajectory = function(self)
	love.graphics.setColor(50, 50, 50)
	love.graphics.setLineStyle( 'smooth' )
	love.graphics.setLineWidth( 1 )
	love.graphics.line( self.dragging.fromX, self.dragging.fromY, self.dragging.toX, self.dragging.toY )
end
player.resetTrajectory = function(self)
	--
	self.dragging.fromX = 0
	self.dragging.fromY = 0
	self.dragging.toX = 0
	self.dragging.toY = 0

end
player.drawMessage = function (self)
	love.graphics.print(self.message, 20, 20)
end